]> git.proxmox.com Git - mirror_ubuntu-jammy-kernel.git/blame - scripts/link-vmlinux.sh
Merge tag 'platform-drivers-x86-v5.12-2' of git://git.kernel.org/pub/scm/linux/kernel...
[mirror_ubuntu-jammy-kernel.git] / scripts / link-vmlinux.sh
CommitLineData
1f2bfbd0 1#!/bin/sh
b2441318 2# SPDX-License-Identifier: GPL-2.0
1f2bfbd0
SR
3#
4# link vmlinux
5#
d151e971
MY
6# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
1f2bfbd0
SR
11#
12# vmlinux
13# ^
14# |
d151e971
MY
15# +--< $(KBUILD_VMLINUX_OBJS)
16# | +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
1f2bfbd0 17# |
3a166fc2
NP
18# +--< $(KBUILD_VMLINUX_LIBS)
19# | +--< lib/lib.a + more
20# |
1f2bfbd0
SR
21# +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
3ec8a5b3
MY
33LD="$1"
34KBUILD_LDFLAGS="$2"
35LDFLAGS_vmlinux="$3"
36
1f2bfbd0
SR
37# Nice output in kbuild format
38# Will be supressed by "make -s"
39info()
40{
41 if [ "${quiet}" != "silent_" ]; then
e83b9f55 42 printf " %-7s %s\n" "${1}" "${2}"
1f2bfbd0
SR
43 fi
44}
45
a8cccdd9
ST
46# Generate a linker script to ensure correct ordering of initcalls.
47gen_initcalls()
48{
49 info GEN .tmp_initcalls.lds
50
51 ${PYTHON} ${srctree}/scripts/jobserver-exec \
52 ${PERL} ${srctree}/scripts/generate_initcall_order.pl \
53 ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS} \
54 > .tmp_initcalls.lds
55}
56
38e89184
ST
57# If CONFIG_LTO_CLANG is selected, collect generated symbol versions into
58# .tmp_symversions.lds
59gen_symversions()
60{
61 info GEN .tmp_symversions.lds
62 rm -f .tmp_symversions.lds
63
64 for o in ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}; do
65 if [ -f ${o}.symversions ]; then
66 cat ${o}.symversions >> .tmp_symversions.lds
67 fi
68 done
69}
70
1f2bfbd0
SR
71# Link of vmlinux.o used for section mismatch analysis
72# ${1} output file
73modpost_link()
74{
a5967db9 75 local objects
38e89184 76 local lds=""
a5967db9 77
6358d6e8 78 objects="--whole-archive \
d151e971 79 ${KBUILD_VMLINUX_OBJS} \
6358d6e8
NP
80 --no-whole-archive \
81 --start-group \
82 ${KBUILD_VMLINUX_LIBS} \
83 --end-group"
84
dc5723b0 85 if [ -n "${CONFIG_LTO_CLANG}" ]; then
a8cccdd9
ST
86 gen_initcalls
87 lds="-T .tmp_initcalls.lds"
88
38e89184
ST
89 if [ -n "${CONFIG_MODVERSIONS}" ]; then
90 gen_symversions
91 lds="${lds} -T .tmp_symversions.lds"
92 fi
93
dc5723b0
ST
94 # This might take a while, so indicate that we're doing
95 # an LTO link
96 info LTO ${1}
97 else
98 info LD ${1}
99 fi
100
38e89184 101 ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${lds} ${objects}
1f2bfbd0
SR
102}
103
6804c1af
PZ
104objtool_link()
105{
b1a1a1a0 106 local objtoolcmd;
6804c1af
PZ
107 local objtoolopt;
108
b1a1a1a0
ST
109 if [ "${CONFIG_LTO_CLANG} ${CONFIG_STACK_VALIDATION}" = "y y" ]; then
110 # Don't perform vmlinux validation unless explicitly requested,
111 # but run objtool on vmlinux.o now that we have an object file.
112 if [ -n "${CONFIG_UNWINDER_ORC}" ]; then
113 objtoolcmd="orc generate"
114 fi
115
116 objtoolopt="${objtoolopt} --duplicate"
117
118 if [ -n "${CONFIG_FTRACE_MCOUNT_USE_OBJTOOL}" ]; then
119 objtoolopt="${objtoolopt} --mcount"
120 fi
121 fi
122
6804c1af 123 if [ -n "${CONFIG_VMLINUX_VALIDATION}" ]; then
b1a1a1a0
ST
124 objtoolopt="${objtoolopt} --noinstr"
125 fi
126
127 if [ -n "${objtoolopt}" ]; then
128 if [ -z "${objtoolcmd}" ]; then
129 objtoolcmd="check"
130 fi
131 objtoolopt="${objtoolopt} --vmlinux"
6804c1af
PZ
132 if [ -z "${CONFIG_FRAME_POINTER}" ]; then
133 objtoolopt="${objtoolopt} --no-fp"
134 fi
b1a1a1a0 135 if [ -n "${CONFIG_GCOV_KERNEL}" ] || [ -n "${CONFIG_LTO_CLANG}" ]; then
6804c1af
PZ
136 objtoolopt="${objtoolopt} --no-unreachable"
137 fi
138 if [ -n "${CONFIG_RETPOLINE}" ]; then
139 objtoolopt="${objtoolopt} --retpoline"
140 fi
141 if [ -n "${CONFIG_X86_SMAP}" ]; then
142 objtoolopt="${objtoolopt} --uaccess"
143 fi
144 info OBJTOOL ${1}
b1a1a1a0 145 tools/objtool/objtool ${objtoolcmd} ${objtoolopt} ${1}
6804c1af
PZ
146 fi
147}
148
1f2bfbd0 149# Link of vmlinux
341dfcf8 150# ${1} - output file
618916a4 151# ${2}, ${3}, ... - optional extra .o files
1f2bfbd0
SR
152vmlinux_link()
153{
154 local lds="${objtree}/${KBUILD_LDS}"
618916a4 155 local output=${1}
a5967db9 156 local objects
af73d78b 157 local strip_debug
1f2bfbd0 158
d7b0827f
LT
159 info LD ${output}
160
618916a4
AN
161 # skip output file argument
162 shift
163
af73d78b
KC
164 # The kallsyms linking does not need debug symbols included.
165 if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
166 strip_debug=-Wl,--strip-debug
167 fi
168
1f2bfbd0 169 if [ "${SRCARCH}" != "um" ]; then
dc5723b0
ST
170 if [ -n "${CONFIG_LTO_CLANG}" ]; then
171 # Use vmlinux.o instead of performing the slow LTO
172 # link again.
173 objects="--whole-archive \
174 vmlinux.o \
175 --no-whole-archive \
176 ${@}"
177 else
178 objects="--whole-archive \
179 ${KBUILD_VMLINUX_OBJS} \
180 --no-whole-archive \
181 --start-group \
182 ${KBUILD_VMLINUX_LIBS} \
183 --end-group \
184 ${@}"
185 fi
a5967db9 186
618916a4 187 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux} \
af73d78b 188 ${strip_debug#-Wl,} \
618916a4 189 -o ${output} \
a5967db9 190 -T ${lds} ${objects}
1f2bfbd0 191 else
6358d6e8 192 objects="-Wl,--whole-archive \
d151e971 193 ${KBUILD_VMLINUX_OBJS} \
6358d6e8
NP
194 -Wl,--no-whole-archive \
195 -Wl,--start-group \
196 ${KBUILD_VMLINUX_LIBS} \
197 -Wl,--end-group \
618916a4 198 ${@}"
a5967db9 199
618916a4 200 ${CC} ${CFLAGS_vmlinux} \
af73d78b 201 ${strip_debug} \
618916a4 202 -o ${output} \
6358d6e8
NP
203 -Wl,-T,${lds} \
204 ${objects} \
a5967db9 205 -lutil -lrt -lpthread
1f2bfbd0
SR
206 rm -f linux
207 fi
208}
209
e83b9f55 210# generate .BTF typeinfo from DWARF debuginfo
341dfcf8
AN
211# ${1} - vmlinux image
212# ${2} - file to dump raw BTF data into
e83b9f55
AN
213gen_btf()
214{
341dfcf8 215 local pahole_ver
e83b9f55 216
581b31c3 217 if ! [ -x "$(command -v ${PAHOLE})" ]; then
2a67a6cc 218 echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
341dfcf8 219 return 1
581b31c3
AN
220 fi
221
e83b9f55 222 pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
21a85bd6
LB
223 if [ "${pahole_ver}" -lt "116" ]; then
224 echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
341dfcf8 225 return 1
e83b9f55
AN
226 fi
227
341dfcf8 228 vmlinux_link ${1}
af73d78b
KC
229
230 info "BTF" ${2}
e83b9f55 231 LLVM_OBJCOPY=${OBJCOPY} ${PAHOLE} -J ${1}
341dfcf8 232
90ceddcb
FS
233 # Create ${2} which contains just .BTF section but no symbols. Add
234 # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
235 # deletes all symbols including __start_BTF and __stop_BTF, which will
236 # be redefined in the linker script. Add 2>/dev/null to suppress GNU
237 # objcopy warnings: "empty loadable segment detected at ..."
238 ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
239 --strip-all ${1} ${2} 2>/dev/null
240 # Change e_type to ET_REL so that it can be used to link final vmlinux.
241 # Unlike GNU ld, lld does not allow an ET_EXEC input.
242 printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
e83b9f55 243}
1f2bfbd0 244
08beb669 245# Create ${2} .S file with all symbols from the ${1} object file
1f2bfbd0
SR
246kallsyms()
247{
1f2bfbd0
SR
248 local kallsymopt;
249
250 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
6895f97e 251 kallsymopt="${kallsymopt} --all-symbols"
1f2bfbd0
SR
252 fi
253
4d5d5664 254 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
c6bda7c9
RR
255 kallsymopt="${kallsymopt} --absolute-percpu"
256 fi
257
2213e9a6
AB
258 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
259 kallsymopt="${kallsymopt} --base-relative"
260 fi
261
08beb669
MY
262 info KSYMS ${2}
263 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${2}
1f2bfbd0
SR
264}
265
8959e392
KC
266# Perform one step in kallsyms generation, including temporary linking of
267# vmlinux.
268kallsyms_step()
269{
270 kallsymso_prev=${kallsymso}
af73d78b
KC
271 kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
272 kallsymso=${kallsyms_vmlinux}.o
08beb669 273 kallsyms_S=${kallsyms_vmlinux}.S
8959e392 274
d7b0827f 275 vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
08beb669
MY
276 kallsyms ${kallsyms_vmlinux} ${kallsyms_S}
277
278 info AS ${kallsyms_S}
279 ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
280 ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
281 -c -o ${kallsymso} ${kallsyms_S}
8959e392
KC
282}
283
1f2bfbd0
SR
284# Create map file with all symbols from ${1}
285# See mksymap for additional details
286mksysmap()
287{
288 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
289}
290
10916706 291sorttable()
1347a2ce 292{
10916706 293 ${objtree}/scripts/sorttable ${1}
1347a2ce
LT
294}
295
1f2bfbd0 296# Delete output files in case of error
1f2bfbd0
SR
297cleanup()
298{
341dfcf8 299 rm -f .btf.*
1f2bfbd0 300 rm -f .tmp_System.map
a8cccdd9 301 rm -f .tmp_initcalls.lds
38e89184 302 rm -f .tmp_symversions.lds
1f2bfbd0
SR
303 rm -f .tmp_vmlinux*
304 rm -f System.map
305 rm -f vmlinux
306 rm -f vmlinux.o
307}
308
ab160dbb
SB
309on_exit()
310{
311 if [ $? -ne 0 ]; then
312 cleanup
313 fi
314}
315trap on_exit EXIT
316
317on_signals()
318{
319 exit 1
320}
321trap on_signals HUP INT QUIT TERM
322
1f2bfbd0
SR
323# Use "make V=1" to debug this script
324case "${KBUILD_VERBOSE}" in
325*1*)
326 set -x
327 ;;
328esac
329
330if [ "$1" = "clean" ]; then
331 cleanup
332 exit 0
333fi
334
335# We need access to CONFIG_ symbols
94cf8acc 336. include/config/auto.conf
1f2bfbd0 337
1f2bfbd0
SR
338# Update version
339info GEN .version
278ae604
MY
340if [ -r .version ]; then
341 VERSION=$(expr 0$(cat .version) + 1)
342 echo $VERSION > .version
1f2bfbd0 343else
278ae604
MY
344 rm -f .version
345 echo 1 > .version
1f2bfbd0
SR
346fi;
347
348# final build of init/
083bc0e1 349${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
1f2bfbd0 350
abac4c89 351#link vmlinux.o
abac4c89 352modpost_link vmlinux.o
6804c1af 353objtool_link vmlinux.o
abac4c89
NP
354
355# modpost vmlinux.o to check for section mismatches
a721588d 356${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
abac4c89 357
898490c0
AG
358info MODINFO modules.builtin.modinfo
359${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
8b41fc44
MY
360info GEN modules.builtin
361# The second line aids cases where multiple modules share the same object.
362tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
363 tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
898490c0 364
7fd78568 365btf_vmlinux_bin_o=""
341dfcf8 366if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
af73d78b
KC
367 btf_vmlinux_bin_o=.btf.vmlinux.bin.o
368 if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
da5fb182
SF
369 echo >&2 "Failed to generate BTF for vmlinux"
370 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
371 exit 1
341dfcf8
AN
372 fi
373fi
374
1f2bfbd0 375kallsymso=""
8959e392 376kallsymso_prev=""
1f2bfbd0
SR
377kallsyms_vmlinux=""
378if [ -n "${CONFIG_KALLSYMS}" ]; then
379
380 # kallsyms support
381 # Generate section listing all symbols and add it into vmlinux
382 # It's a three step process:
383 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
384 # but __kallsyms is empty.
385 # Running kallsyms on that gives us .tmp_kallsyms1.o with
386 # the right size
387 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
388 # the right size, but due to the added section, some
389 # addresses have shifted.
390 # From here, we generate a correct .tmp_kallsyms2.o
7e2b37c9
NP
391 # 3) That link may have expanded the kernel image enough that
392 # more linker branch stubs / trampolines had to be added, which
393 # introduces new names, which further expands kallsyms. Do another
394 # pass if that is the case. In theory it's possible this results
395 # in even more stubs, but unlikely.
396 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
397 # other bugs.
398 # 4) The correct ${kallsymso} is linked into the final vmlinux.
1f2bfbd0
SR
399 #
400 # a) Verify that the System.map from vmlinux matches the map from
401 # ${kallsymso}.
402
8959e392
KC
403 kallsyms_step 1
404 kallsyms_step 2
1f2bfbd0 405
7e2b37c9 406 # step 3
8959e392
KC
407 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
408 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
7e2b37c9
NP
409
410 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
8959e392 411 kallsyms_step 3
1f2bfbd0
SR
412 fi
413fi
414
d7b0827f 415vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
e83b9f55 416
c9a0f3b8 417# fill in BTF IDs
017dab34
JO
418if [ -n "${CONFIG_DEBUG_INFO_BTF}" -a -n "${CONFIG_BPF}" ]; then
419 info BTFIDS vmlinux
420 ${RESOLVE_BTFIDS} vmlinux
c9a0f3b8
JO
421fi
422
10916706
SZ
423if [ -n "${CONFIG_BUILDTIME_TABLE_SORT}" ]; then
424 info SORTTAB vmlinux
f14bf6a3
SZ
425 if ! sorttable vmlinux; then
426 echo >&2 Failed to sort kernel tables
427 exit 1
428 fi
1347a2ce
LT
429fi
430
1f2bfbd0
SR
431info SYSMAP System.map
432mksysmap vmlinux System.map
433
434# step a (see comment above)
435if [ -n "${CONFIG_KALLSYMS}" ]; then
436 mksysmap ${kallsyms_vmlinux} .tmp_System.map
437
438 if ! cmp -s System.map .tmp_System.map; then
5369f550 439 echo >&2 Inconsistent kallsyms data
367e43c5 440 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
1f2bfbd0
SR
441 exit 1
442 fi
443fi